import { renderless, api } from '@opentinyvue/vue-renderless/date-panel/vue';
import { directive, setup, props } from '@opentinyvue/vue-common';
import { language } from '@opentinyvue/vue-locale';
import { Clickoutside } from '@opentinyvue/vue-directive';
import Time from '@opentinyvue/vue-time';
import DateTable from '@opentinyvue/vue-date-table';
import YearTable from '@opentinyvue/vue-year-table';
import MonthTable from '@opentinyvue/vue-month-table';
import Input from '@opentinyvue/vue-input';
import Button from '@opentinyvue/vue-button';
import { IconDoubleRight, IconDoubleLeft, IconChevronLeft, IconChevronRight, IconChevronDown, IconChevronUp } from '@opentinyvue/vue-icon';
import Popup from '@opentinyvue/vue-popup';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
var classes = {
  "picker-panel": "w-96 text-color-text-primary text-xs shadow-md bg-color-bg-1 rounded leading-4 my-0.5 mx-0",
  "picker-panel-body": "after:content-[''] after:table after:clear-both",
  "content": "relative py-0 px-4",
  "header": "p-4 h-12 text-center",
  "bordered": "mb-0 pb-3",
  "disabled": "text-color-text-disabled",
  "icon-btn": "text-sm leading-4 fill-color-text-primary border-0 cursor-pointer outline-0 hover:fill-color-brand",
  "header-label": "text-xs font-medium py-0 px-1 text-center text-color-text-primary align-middle",
  "body-content": "float-left w-1/2 box-border m-0 pt-4 pr-4 pb-1.5 pl-4",
  "today": "border border-solid border-color-border-focus",
  "footer": "border-t border-t-color-bg-3 py-3 px-4 bg-color-bg-1 overflow-hidden rounded-b",
  "link-btn": "align-middle rounded",
  "time-header": "relative text-xs h-10 leading-10 table w-full box-border border-b border-b-color-bg-3",
  "editor-wrap": "relative table-cell px-1",
  "sidebar": "absolute top-0 bottom-0 w-28 border-r border-r-color-bg-3 box-border pt-5 bg-color-bg-1 overflow-auto",
  "sidebar-btn": "block w-24 my-0 mx-auto rounded border-0 bg-transparent leading-8 text-xs text-color-text-primary pl-4 text-left outline-0 cursor-pointer truncate hover:bg-color-bg-2"
};
var render = function render2() {
  var _vm$state$shortcuts, _vm$state$shortcuts2;
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("transition", {
    on: {
      "after-enter": _vm.handleEnter,
      "after-leave": _vm.handleLeave
    }
  }, [_c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.visible,
      expression: "state.visible"
    }],
    class: _vm.m([_vm.gcls("picker-panel"), {
      "w-80": _vm.state.currentView === "year"
    }, _vm.state.popperClass]),
    attrs: {
      "data-tag": "tiny-picker-panel tiny-date-picker tiny-popper"
    }
  }, [_c("div", {
    class: _vm.gcls("picker-panel-body"),
    attrs: {
      "data-tag": "tiny-picker-panel__body-wrapper"
    }
  }, [_vm._t("sidebar", null, {
    "dataTag": "tiny-picker-panel__sidebar"
  }), (_vm$state$shortcuts = _vm.state.shortcuts) !== null && _vm$state$shortcuts !== void 0 && _vm$state$shortcuts.length ? _c("div", {
    class: _vm.gcls("sidebar"),
    attrs: {
      "data-tag": "tiny-picker-panel__sidebar"
    }
  }, _vm._l(_vm.state.shortcuts, function(shortcut, key) {
    return _c("button", {
      key,
      class: _vm.gcls("sidebar-btn"),
      attrs: {
        "type": "button",
        "data-tag": "tiny-picker-panel__shortcut"
      },
      on: {
        "click": function click($event) {
          return _vm.handleShortcutClick(shortcut);
        }
      }
    }, [_vm._v(" " + _vm._s(shortcut.text) + " ")]);
  }), 0) : _vm._e(), _c("div", {
    class: [_vm.gcls("picker-panel-body"), {
      "ml-28": _vm.slots.sidebar || ((_vm$state$shortcuts2 = _vm.state.shortcuts) === null || _vm$state$shortcuts2 === void 0 ? void 0 : _vm$state$shortcuts2.length)
    }],
    attrs: {
      "data-tag": "tiny-picker-panel__body"
    }
  }, [_vm.state.showTime ? _c("div", {
    class: _vm.gcls("time-header"),
    attrs: {
      "data-tag": "tiny-date-picker__time-header"
    }
  }, [_c("span", {
    class: _vm.gcls("editor-wrap"),
    attrs: {
      "data-tag": "tiny-date-picker__editor-wrap"
    }
  }, [_c("tiny-input", {
    attrs: {
      "placeholder": _vm.t("ui.datepicker.selectDate"),
      "modelValue": _vm.state.visibleDate,
      "size": "small"
    },
    on: {
      "update:modelValue": function updateModelValue(val) {
        return _vm.state.userInputDate = val;
      },
      "change": _vm.handleVisibleDateChange
    }
  })], 1), _c("span", {
    directives: [{
      name: "clickoutside",
      rawName: "v-clickoutside",
      value: _vm.handleTimePickClose,
      expression: "handleTimePickClose"
    }],
    class: _vm.gcls("editor-wrap"),
    attrs: {
      "data-tag": "tiny-date-picker__editor-wrap"
    }
  }, [_c("tiny-input", {
    ref: "input",
    attrs: {
      "placeholder": _vm.t("ui.datepicker.selectTime"),
      "modelValue": _vm.state.visibleTime,
      "size": "small"
    },
    on: {
      "focus": function focus($event) {
        _vm.state.timePickerVisible = true;
      },
      "update:modelValue": function updateModelValue(val) {
        return _vm.state.userInputTime = val;
      },
      "change": _vm.handleVisibleTimeChange
    }
  }), _c("time-picker", {
    ref: "timepicker",
    attrs: {
      "step": _vm.step,
      "time-arrow-control": _vm.state.arrowControl,
      "show": _vm.state.timePickerVisible,
      "value": _vm.state.date
    },
    on: {
      "pick": _vm.handleTimePick
    }
  })], 1)]) : _vm._e(), _c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.currentView !== "time",
      expression: "state.currentView !== 'time'"
    }],
    class: [_vm.gcls("header"), ["month", "year", "years", "yearrange"].includes(_vm.state.currentView) && _vm.gcls("bordered")],
    attrs: {
      "data-tag": "tiny-date-picker__header"
    }
  }, [_c("button", {
    class: [_vm.gcls("icon-btn"), "float-left"],
    attrs: {
      "type": "button",
      "aria-label": _vm.t("ui.datepicker.prevYear"),
      "data-tag": "tiny-picker-panel__icon-btn tiny-date-picker__prev-btn tiny-icon-arrow-left"
    },
    on: {
      "click": _vm.cusPrevYear
    }
  }, [_c("icon-double-left")], 1), _c("button", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.currentView === "date",
      expression: "state.currentView === 'date'"
    }],
    class: [_vm.gcls("icon-btn"), "float-left"],
    attrs: {
      "type": "button",
      "aria-label": _vm.t("ui.datepicker.prevMonth"),
      "data-tag": "tiny-picker-panel__icon-btn tiny-date-picker__prev-btn tiny-icon-arrow-left"
    },
    on: {
      "click": _vm.cusPrevMonth
    }
  }, [_c("icon-chevron-left")], 1), _c("span", {
    class: [_vm.gcls("header-label")],
    attrs: {
      "role": "button",
      "data-tag": "tiny-date-picker__header-label"
    },
    on: {
      "click": function click($event) {
        return _vm.showHeaderPicker("Year");
      }
    }
  }, [_vm._v(_vm._s(_vm.state.yearLabel))]), _c("span", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.currentView === "date",
      expression: "state.currentView === 'date'"
    }],
    class: [_vm.gcls("header-label"), {
      "text-color-brand": _vm.state.currentView === "month"
    }],
    attrs: {
      "role": "button",
      "data-tag": "tiny-date-picker__header-label"
    },
    on: {
      "click": function click($event) {
        return _vm.showHeaderPicker("Month");
      }
    }
  }, [_vm._v(_vm._s(_vm.t("ui.datepicker.month" + (_vm.state.month + 1))))]), _c("button", {
    class: [_vm.gcls("icon-btn"), "float-right"],
    attrs: {
      "type": "button",
      "aria-label": _vm.t("ui.datepicker.nextYear"),
      "data-tag": "tiny-picker-panel__icon-btn tiny-date-picker__next-btn tiny-icon-arrow-right"
    },
    on: {
      "click": _vm.cusNextYear
    }
  }, [_c("icon-double-right")], 1), _c("button", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.currentView === "date",
      expression: "state.currentView === 'date'"
    }],
    class: [_vm.gcls("icon-btn"), "float-right"],
    attrs: {
      "type": "button",
      "aria-label": _vm.t("ui.datepicker.nextMonth"),
      "data-tag": "tiny-picker-panel__icon-btn tiny-date-picker__next-btn tiny-icon-arrow-right"
    },
    on: {
      "click": _vm.cusNextMonth
    }
  }, [_c("icon-chevron-right")], 1)]), _c("div", {
    class: _vm.gcls("content"),
    attrs: {
      "data-tag": "tiny-picker-panel__content"
    }
  }, [_vm.state.currentView === "date" ? _c("date-table", {
    ref: "dateTable",
    attrs: {
      "selection-mode": _vm.state.selectionMode,
      "first-day-of-week": _vm.state.firstDayOfWeek,
      "value": _vm.state.value,
      "default-value": _vm.state.defaultValue ? new Date(_vm.state.defaultValue) : null,
      "date": _vm.state.date,
      "cell-class-name": _vm.state.cellClassName,
      "disabled-date": _vm.state.disabledDate,
      "show-week-number": _vm.showWeekNumber,
      "format-weeks": _vm.formatWeeks
    },
    on: {
      "pick": _vm.handleDatePick
    }
  }) : _vm._e(), ["year", "years", "yearrange"].includes(_vm.state.currentView) ? _c("year-table", {
    ref: "yearTable",
    attrs: {
      "value": _vm.state.value,
      "default-value": _vm.state.defaultValue ? new Date(_vm.state.defaultValue) : null,
      "date": _vm.state.date,
      "disabled-date": _vm.state.disabledDate,
      "selection-mode": _vm.state.selectionMode,
      "start-year": _vm.state.startYear
    },
    on: {
      "pick": _vm.handleYearPick
    }
  }) : _vm._e(), _vm.state.currentView === "month" ? _c("month-table", {
    ref: "monthTable",
    attrs: {
      "value": _vm.state.value,
      "default-value": _vm.state.defaultValue ? new Date(_vm.state.defaultValue) : null,
      "date": _vm.state.date,
      "disabled-date": _vm.state.disabledDate
    },
    on: {
      "pick": _vm.handleMonthPick
    }
  }) : _vm._e()], 1)])], 2), _vm.state.isShowTz || _vm.state.timezone.isServiceTimezone ? _c("div", {
    directives: [{
      name: "clickoutside",
      rawName: "v-clickoutside",
      value: _vm.handleTzPickClose,
      expression: "handleTzPickClose"
    }],
    staticClass: "tiny-picker-panel__timezone",
    attrs: {
      "data-tag": "tiny-picker-panel__timezone"
    }
  }, [_c("tiny-input", {
    attrs: {
      "disabled": _vm.state.timezone.isServiceTimezone,
      "placeholder": _vm.t("ui.datepicker.timezone")
    },
    on: {
      "update:modelValue": _vm.searchTz
    },
    scopedSlots: _vm._u([{
      key: "suffix",
      fn: function fn() {
        return [_c(_vm.state.showpopup ? "IconChevronDown" : "IconChevronUp", {
          tag: "component",
          attrs: {
            "fill": "#ccc"
          },
          on: {
            "click": _vm.toggleTz
          }
        })];
      },
      proxy: true
    }], null, false, 3034754380),
    model: {
      value: _vm.state.tz,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "tz", $$v);
      },
      expression: "state.tz"
    }
  }), _c("div", {
    staticClass: "tiny-picker-panel__tzlist",
    attrs: {
      "data-tag": "tiny-picker-panel__tzlist"
    }
  }, [_c("tiny-popup", {
    attrs: {
      "overlay": false,
      "aui_mode": "mobile",
      "position": "bottom",
      "duration": 0.2,
      "closeable": false
    },
    model: {
      value: _vm.state.showpopup,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "showpopup", $$v);
      },
      expression: "state.showpopup"
    }
  }, [_c("div", {
    attrs: {
      "data-tag": "tzlist"
    }
  }, [_c("ul", _vm._l(_vm.state.renderTzdata, function(tz, index) {
    return _c("li", {
      directives: [{
        name: "show",
        rawName: "v-show",
        value: !tz.visible,
        expression: "!tz.visible"
      }],
      key: index,
      staticClass: "tiny-picker-panel__tzlist-li",
      attrs: {
        "data-tag": "tiny-picker-panel__tzlist-li",
        "title": tz.name
      },
      on: {
        "click": function click($event) {
          return _vm.selectTz(tz);
        }
      }
    }, [_vm._v(" " + _vm._s(tz.name) + " ")]);
  }), 0)])])], 1)], 1) : _vm._e(), _c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.isShowFooter,
      expression: "state.isShowFooter"
    }],
    class: _vm.gcls("footer"),
    attrs: {
      "data-tag": "tiny-picker-panel__footer"
    }
  }, [_vm._t("default", function() {
    return [_c("tiny-button", {
      directives: [{
        name: "show",
        rawName: "v-show",
        value: !["dates", "years"].includes(_vm.state.selectionMode),
        expression: "!['dates', 'years'].includes(state.selectionMode)"
      }],
      class: _vm.gcls("link-btn"),
      attrs: {
        "size": "mini",
        "type": "text",
        "data-tag": "tiny-picker-panel__link-btn"
      },
      on: {
        "click": _vm.changeToNow
      }
    }, [_vm._v(" " + _vm._s(_vm.t("ui.datepicker.now")) + " ")])];
  }), _c("tiny-button", {
    class: ["float-right", _vm.gcls("link-btn")],
    attrs: {
      "type": "primary",
      "size": "mini",
      "data-tag": "tiny-picker-panel__link-btn"
    },
    on: {
      "click": _vm.confirm
    }
  }, [_vm._v(" " + _vm._s(_vm.t("ui.datepicker.confirm")) + " ")])], 2)])]);
};
var staticRenderFns = [];
var __vue2_script = {
  directives: directive({
    Clickoutside
  }),
  components: {
    TimePicker: Time,
    YearTable,
    MonthTable,
    DateTable,
    TinyInput: Input,
    TinyButton: Button,
    TinyPopup: Popup,
    IconDoubleRight: IconDoubleRight(),
    IconDoubleLeft: IconDoubleLeft(),
    IconChevronLeft: IconChevronLeft(),
    IconChevronRight: IconChevronRight(),
    IconChevronDown: IconChevronDown(),
    IconChevronUp: IconChevronUp()
  },
  props: _extends({}, props, {
    emitter: Object,
    step: {
      type: Object,
      default: function _default() {
        return {
          hour: 1,
          minute: 1,
          second: 1
        };
      }
    },
    showWeekNumber: {
      type: Boolean,
      default: false
    },
    formatWeeks: Function,
    nowClick: {
      type: Function
    }
  }),
  emits: ["pick", "select-change", "dodestroy"],
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api,
      classes,
      extendOptions: {
        language
      }
    });
  }
};
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var mobileFirst = /* @__PURE__ */ function() {
  return __component__.exports;
}();

export { mobileFirst as default };
